#ifndef CACHE_H_INCLUDED
#define CACHE_H_INCLUDED

#define TAILLECACHE 1000 /* taille de l'espace disponible */
static char cache[TAILLECACHE]; /* espace mémoire pour allouer */
static char *p_allocation = cache; /* espace libre suivant */

/* Retourne un pointeur sur n caractères */
char *allouer(int n)
{
    if (cache + TAILLECACHE - p_allocation >= n) {
        /* Assez de place disponible dans le cache pour allouer */
        p_allocation += n;
        return p_allocation - n; /* retourne l'ancien pointeur */
    } else {
        /* pas assez de place */
        return 0;
    }
}


/* libère l'espace mémoire pointé par p */
void liberer(char *p)
{
    if (p >= cache && p < cache+TAILLECACHE) {
        p_allocation = p;
    }
}

char *getIndex()
{
    return p_allocation;
}

void echanger (int x, int y)
{
    int temp;
    temp = x;
    x = y;
    y = temp;
}

void pechanger (int *x, int *y)
{
    int temp;
    temp = *x;
    *x = *y;
    *y = temp;
}

#endif // CACHE_H_INCLUDED

